
void RaPropSheet::AboutPage_AddPage(QTabWidget* TabWidgetRaConfig)
{
//===============================================================================
//About Page
//===============================================================================
    AboutPage_tab = new QWidget( TabWidgetRaConfig, "AboutPage_tab" );

    About_TextLabel_Logo = new QLabel( AboutPage_tab, "About_TextLabel_Logo" );
    About_TextLabel_Logo->setGeometry( QRect( 30, 30, 161, 91 ) );

    About_ButtonGroupUI = new QButtonGroup( AboutPage_tab, "About_ButtonGroupUI" );
    About_ButtonGroupUI->setGeometry( QRect( 30, 140, 510, 60 ) );

    About_Label_UIVersion = new QLabel( About_ButtonGroupUI, "About_Label_UIVersion" );
    About_Label_UIVersion->setGeometry( QRect( 20, 20, 80, 30 ) );

    About_TextLabel_UIVersion = new QLabel( About_ButtonGroupUI, "About_TextLabel_UIVersion" );
    About_TextLabel_UIVersion->setGeometry( QRect( 110, 20, 100, 30 ) );

    About_Label_UIDate = new QLabel( About_ButtonGroupUI, "About_Label_UIDate" );
    About_Label_UIDate->setGeometry( QRect( 280, 20, 80, 30 ) );

    About_TextLabel_UIDate = new QLabel( About_ButtonGroupUI, "About_TextLabel_UIDate" );
    About_TextLabel_UIDate->setGeometry( QRect( 370, 20, 100, 30 ) );

    About_ButtonGroupNIC = new QButtonGroup( AboutPage_tab, "About_ButtonGroupNIC" );
    About_ButtonGroupNIC->setGeometry( QRect( 30, 230, 510, 60 ) );

    About_Label_NICVersion = new QLabel( About_ButtonGroupNIC, "About_Label_NICVersion" );
    About_Label_NICVersion->setGeometry( QRect( 20, 20, 80, 30 ) );

    About_TextLabel_NICVersion = new QLabel( About_ButtonGroupNIC, "About_TextLabel_NICVersion" );
    About_TextLabel_NICVersion->setGeometry( QRect( 110, 20, 100, 30 ) );

    About_Label_NICDate = new QLabel( About_ButtonGroupNIC, "About_Label_NICDate" );
    About_Label_NICDate->setGeometry( QRect( 280, 20, 80, 30 ) );

    About_TextLabel_NICDate = new QLabel( About_ButtonGroupNIC, "About_TextLabel_NICDate" );
    About_TextLabel_NICDate->setGeometry( QRect( 370, 20, 100, 30 ) );

    About_ButtonGroupMAC = new QButtonGroup( AboutPage_tab, "About_ButtonGroupMAC" );
    About_ButtonGroupMAC->setGeometry( QRect( 30, 320, 510, 60 ) );

    About_Label_PhyAddress = new QLabel( About_ButtonGroupMAC, "About_Label_PhyAddress" );
    About_Label_PhyAddress->setGeometry( QRect( 20, 20, 130, 30 ) );

    About_TextLabel_PhyAddress = new QLabel( About_ButtonGroupMAC, "About_TextLabel_PhyAddress" );
    About_TextLabel_PhyAddress->setGeometry( QRect( 170, 20, 170, 30 ) );

    TabWidgetRaConfig->insertTab( AboutPage_tab,"About");

    //-----------------------------------------------------------------------
    

    About_TextLabel_Logo->setText("");
    About_TextLabel_Logo->setPixmap( uic_load_pixmap_RaPropSheet( "rtlogo.png" ) );

    About_ButtonGroupUI->setTitle("Configuration Utility - Rt2570");

    About_Label_UIVersion->setText("Version:");

    About_TextLabel_UIVersion->setText(CONFIGURATION_UI_VERSION);

    About_Label_UIDate->setText("Date:");

    About_TextLabel_UIDate->setText(CONFIGURATION_UI_DATE);

    About_ButtonGroupNIC->setTitle("NIC Driver");

    About_Label_NICVersion->setText("Version:");

    About_Label_NICDate->setText("Date:");

    About_ButtonGroupMAC->setTitle("Mac Address");

    About_Label_PhyAddress->setText("Phy_Address:");

    About_TextLabel_PhyAddress->setText("");	
}

bool RaPropSheet::AboutPage_OnInitDialog()
{

}

void RaPropSheet::AboutPage_OnSetActive()
{
    NDIS_802_11_MAC_ADDRESS         CurrentAddress;
    RT_VERSION_INFO                 DriverVersionInfo;
    char                            tmp[40];

    
    if( OidQueryInformation(OID_802_3_CURRENT_ADDRESS, m_nSocketId, m_strDeviceName, &CurrentAddress, sizeof(CurrentAddress)) >= 0)
    {
        sprintf(tmp, "%02X-%02X-%02X-%02X-%02X-%02X", CurrentAddress[0], CurrentAddress[1],
            CurrentAddress[2], CurrentAddress[3], CurrentAddress[4], CurrentAddress[5]);
    }
    else
    {
        sprintf(tmp, "");
    }
        About_TextLabel_PhyAddress->setText( (const char *)tmp );

    if (OidQueryInformation(RT_OID_VERSION_INFO, m_nSocketId, m_strDeviceName, &DriverVersionInfo, sizeof(DriverVersionInfo)) >= 0)
    {
        sprintf(tmp, "%d.%d.%d.%d", DriverVersionInfo.DriverVersionW, DriverVersionInfo.DriverVersionX, DriverVersionInfo.DriverVersionY, DriverVersionInfo.DriverVersionZ);
        About_TextLabel_NICVersion->setText(tmp);
        sprintf(tmp, "%04d-%02d-%02d", DriverVersionInfo.DriverBuildYear, DriverVersionInfo.DriverBuildMonth, DriverVersionInfo.DriverBuildDay);
        About_TextLabel_NICDate->setText(tmp);
    }
}

void RaPropSheet::AboutPage_OnKillActive()
{

}

void RaPropSheet::AboutPage_OnTimer(int nIDEvent)
{

}
 
