#include <stdio.h>
#include "DebugPrint.h"

#include <qvariant.h>
#include <qapplication.h>
#include <qgroupbox.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qheader.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qprogressbar.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qmime.h>
#include <qdragobject.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qmessagebox.h>
#include <unistd.h>
#include <errno.h>

FILE* pFile; 

char DebugPrntBuf[DEBUG_PRINT_BUF_MAX_LEN];

void DebugPrintInit()
{
#if (DEBUG_PRINT_TO_WHERE==DEBUG_PRINT_TO_FILE)
  pFile = fopen ("/tmp/raconfig2500.dbg","wt"); 
#endif
}

void DebugPrintEnd()
{
#if (DEBUG_PRINT_TO_WHERE==DEBUG_PRINT_TO_FILE)
  if (pFile!=NULL)
  {
    fclose (pFile); 
    pFile = NULL;            
  } 
#endif  
}

void DebugPrint(char* buf)
{

#if (DEBUG_PRINT_TO_WHERE==DEBUG_PRINT_TO_FILE)
  pFile = fopen ("/tmp/raconfig2500.dbg","at"); 
  if (pFile!=NULL)
  {
    fprintf(pFile, buf);
    fclose (pFile); 
    pFile = NULL;     
  } 
#endif  

#if (DEBUG_PRINT_TO_WHERE==DEBUG_PRINT_TO_QTVIEW)
	qDebug("%s", buf);
#endif

}