

// Extra Info 
EXTRA_INFO_DATA ExtraInfoTable[] = 
{
	{GENERAL_LINK_UP,		IDS_GENERAL_LINK_UP},
	{GENERAL_LINK_DOWN,		IDS_GENERAL_LINK_DOWN},
	{HW_RADIO_OFF,			IDS_HW_RADIO_OFF},
	{SW_RADIO_OFF,			IDS_SW_RADIO_OFF},
	{AUTH_FAIL,			IDS_AUTH_FAIL},
	{AUTH_FAIL_KEYS,		IDS_AUTH_FAIL_KEYS},
	{ASSOC_FAIL,			IDS_ASSOC_FAIL},
	{EAP_MIC_FAILURE,		IDS_EAP_MIC_FAILURE},
	{EAP_4WAY_TIMEOUT,		IDS_EAP_4WAY_TIMEOUT},
	{EAP_GROUP_KEY_TIMEOUT,	IDS_EAP_GROUP_KEY_TIMEOUT},
	{EAP_SUCCESS,			IDS_EAP_SUCCESS},
};

void RaPropSheet::LinkStatusPage_AddPage(QTabWidget* TabWidgetRaConfig)
{
    DebugPrint("<func>RaPropSheet::LinkStatusPage_AddPage()==>\n");

//===============================================================================
//LinkStatus Page
//===============================================================================
   LinkStatusPage_tab = new QWidget( TabWidgetRaConfig, "LinkStatusPage_tab" );

    LinkStatusPage_Label_LinkSpeed_RX = new QLabel( LinkStatusPage_tab, "LinkStatusPage_Label_LinkSpeed_RX" );
    LinkStatusPage_Label_LinkSpeed_RX->setGeometry( QRect( 380, 90, 60, 20 ) );

    LinkStatusPage_TextLabel_Status = new QLabel( LinkStatusPage_tab, "LinkStatusPage_TextLabel_Status" );
    LinkStatusPage_TextLabel_Status->setGeometry( QRect( 140, 10, 410, 20 ) );
    LinkStatusPage_TextLabel_Status->setFrameShape( QLabel::LineEditPanel );
    LinkStatusPage_TextLabel_Status->setFrameShadow( QLabel::Sunken );

    LinkStatusPage_Label_Channel = new QLabel( LinkStatusPage_tab, "LinkStatusPage_Label_Channel" );
    LinkStatusPage_Label_Channel->setGeometry( QRect( 340, 50, 60, 20 ) );

    LinkStatusPage_TextLabel_ExtraInfo = new QLabel( LinkStatusPage_tab, "LinkStatusPage_TextLabel_ExtraInfo" );
    LinkStatusPage_TextLabel_ExtraInfo->setGeometry( QRect( 140, 50, 190, 20 ) );
    LinkStatusPage_TextLabel_ExtraInfo->setFrameShape( QLabel::LineEditPanel );
    LinkStatusPage_TextLabel_ExtraInfo->setFrameShadow( QLabel::Sunken );

    LinkStatusPage_ProgressBar_Signal = new QProgressBar( LinkStatusPage_tab, "LinkStatusPage_ProgressBar_Signal" );
    LinkStatusPage_ProgressBar_Signal->setGeometry( QRect( 140, 260, 410, 22 ) );

    LinkStatusPage_Label_Status = new QLabel( LinkStatusPage_tab, "LinkStatusPage_Label_Status" );
    LinkStatusPage_Label_Status->setGeometry( QRect( 20, 10, 90, 20 ) );

    LinkStatusPage_Label_ExtraInfo = new QLabel( LinkStatusPage_tab, "LinkStatusPage_Label_ExtraInfo" );
    LinkStatusPage_Label_ExtraInfo->setGeometry( QRect( 20, 50, 90, 20 ) );

    LinkStatusPage_Label_ThroughputM = new QLabel( LinkStatusPage_tab, "LinkStatusPage_Label_ThroughputM" );
    LinkStatusPage_Label_ThroughputM->setGeometry( QRect( 20, 130, 100, 20 ) );

    LinkStatusPage_Label_LinkQuality = new QLabel( LinkStatusPage_tab, "LinkStatusPage_Label_LinkQuality" );
    LinkStatusPage_Label_LinkQuality->setGeometry( QRect( 20, 200, 120, 20 ) );

    LinkStatusPage_Label_NoiseLevel = new QLabel( LinkStatusPage_tab, "LinkStatusPage_Label_NoiseLevel" );
    LinkStatusPage_Label_NoiseLevel->setGeometry( QRect( 20, 320, 120, 20 ) );

    LinkStatusPage_ProgressBar_NoiseLevel = new QProgressBar( LinkStatusPage_tab, "LinkStatusPage_ProgressBar_NoiseLevel" );
    LinkStatusPage_ProgressBar_NoiseLevel->setGeometry( QRect( 140, 320, 410, 22 ) );

    LinkStatusPage_Label_SignalStrength = new QLabel( LinkStatusPage_tab, "LinkStatusPage_Label_SignalStrength" );
    LinkStatusPage_Label_SignalStrength->setGeometry( QRect( 20, 257, 110, 20 ) );

    LinkStatusPage_TextLabel_NoiseLevelStrengthWord = new QLabel( LinkStatusPage_tab, "LinkStatusPage_TextLabel_NoiseLevelStrengthWord" );
    LinkStatusPage_TextLabel_NoiseLevelStrengthWord->setGeometry( QRect( 140, 300, 90, 20 ) );

    LinkStatusPage_TextLabel_NoiseLevelStrengthPercent = new QLabel( LinkStatusPage_tab, "LinkStatusPage_TextLabel_NoiseLevelStrengthPercent" );
    LinkStatusPage_TextLabel_NoiseLevelStrengthPercent->setGeometry( QRect( 230, 300, 90, 20 ) );

    LinkStatusPage_TextLabel_SignalStrengthPercent = new QLabel( LinkStatusPage_tab, "LinkStatusPage_TextLabel_SignalStrengthPercent" );
    LinkStatusPage_TextLabel_SignalStrengthPercent->setGeometry( QRect( 230, 240, 90, 20 ) );

    LinkStatusPage_CheckBox_dbm = new QCheckBox( LinkStatusPage_tab, "LinkStatusPage_CheckBox_dbm" );
    LinkStatusPage_CheckBox_dbm->setGeometry( QRect( 400, 240, 110, 20 ) );

    LinkStatusPage_ProgressBar_Link = new QProgressBar( LinkStatusPage_tab, "LinkStatusPage_ProgressBar_Link" );
    LinkStatusPage_ProgressBar_Link->setGeometry( QRect( 140, 200, 410, 22 ) );

    LinkStatusPage_TextLabel_LinkStrengthWord = new QLabel( LinkStatusPage_tab, "LinkStatusPage_TextLabel_LinkStrengthWord" );
    LinkStatusPage_TextLabel_LinkStrengthWord->setGeometry( QRect( 140, 180, 90, 20 ) );

    LinkStatusPage_TextLabel_SignalStrengthWord = new QLabel( LinkStatusPage_tab, "LinkStatusPage_TextLabel_SignalStrengthWord" );
    LinkStatusPage_TextLabel_SignalStrengthWord->setGeometry( QRect( 140, 240, 90, 20 ) );

    LinkStatusPage_TextLabel_LinkStrengthPercent = new QLabel( LinkStatusPage_tab, "LinkStatusPage_TextLabel_LinkStrengthPercent" );
    LinkStatusPage_TextLabel_LinkStrengthPercent->setGeometry( QRect( 230, 180, 90, 20 ) );

    LinkStatusPage_Label_LinkSpeedM = new QLabel( LinkStatusPage_tab, "LinkStatusPage_Label_LinkSpeedM" );
    LinkStatusPage_Label_LinkSpeedM->setGeometry( QRect( 20, 90, 100, 20 ) );

    LinkStatusPage_Label_LinkSpeed_TX = new QLabel( LinkStatusPage_tab, "LinkStatusPage_Label_LinkSpeed_TX" );
    LinkStatusPage_Label_LinkSpeed_TX->setGeometry( QRect( 140, 90, 60, 20 ) );

    LinkStatusPage_TextLabel_TxRate = new QLabel( LinkStatusPage_tab, "LinkStatusPage_TextLabel_TxRate" );
    LinkStatusPage_TextLabel_TxRate->setGeometry( QRect( 220, 90, 70, 20 ) );
    LinkStatusPage_TextLabel_TxRate->setFrameShape( QLabel::LineEditPanel );
    LinkStatusPage_TextLabel_TxRate->setFrameShadow( QLabel::Sunken );

    LinkStatusPage_TextLabel_TxThroughput = new QLabel( LinkStatusPage_tab, "LinkStatusPage_TextLabel_TxThroughput" );
    LinkStatusPage_TextLabel_TxThroughput->setGeometry( QRect( 220, 130, 70, 20 ) );
    LinkStatusPage_TextLabel_TxThroughput->setFrameShape( QLabel::LineEditPanel );
    LinkStatusPage_TextLabel_TxThroughput->setFrameShadow( QLabel::Sunken );

    LinkStatusPage_TextLabel_RxThroughput = new QLabel( LinkStatusPage_tab, "LinkStatusPage_TextLabel_RxThroughput" );
    LinkStatusPage_TextLabel_RxThroughput->setGeometry( QRect( 460, 130, 70, 20 ) );
    LinkStatusPage_TextLabel_RxThroughput->setFrameShape( QLabel::LineEditPanel );
    LinkStatusPage_TextLabel_RxThroughput->setFrameShadow( QLabel::Sunken );

    LinkStatusPage_Label_Throughput_TX = new QLabel( LinkStatusPage_tab, "LinkStatusPage_Label_Throughput_TX" );
    LinkStatusPage_Label_Throughput_TX->setGeometry( QRect( 140, 130, 60, 20 ) );

    LinkStatusPage_Label_Throughput_RX = new QLabel( LinkStatusPage_tab, "LinkStatusPage_Label_Throughput_RX" );
    LinkStatusPage_Label_Throughput_RX->setGeometry( QRect( 380, 130, 60, 20 ) );

    LinkStatusPage_TextLabel_RxRate = new QLabel( LinkStatusPage_tab, "LinkStatusPage_TextLabel_RxRate" );
    LinkStatusPage_TextLabel_RxRate->setGeometry( QRect( 460, 90, 70, 20 ) );
    LinkStatusPage_TextLabel_RxRate->setFrameShape( QLabel::LineEditPanel );
    LinkStatusPage_TextLabel_RxRate->setFrameShadow( QLabel::Sunken );

    LinkStatusPage_TextLabel_Channel = new QLabel( LinkStatusPage_tab, "LinkStatusPage_TextLabel_Channel" );
    LinkStatusPage_TextLabel_Channel->setGeometry( QRect( 410, 50, 140, 20 ) );
    LinkStatusPage_TextLabel_Channel->setFrameShape( QLabel::LineEditPanel );
    LinkStatusPage_TextLabel_Channel->setFrameShadow( QLabel::Sunken );
    
    TabWidgetRaConfig->insertTab( LinkStatusPage_tab,"Link Status");
  
    DebugPrint("<func>RaPropSheet::LinkStatusPage_AddPage()<==\n");    
}

bool RaPropSheet::LinkStatusPage_OnInitDialog()
{
    DebugPrint("<func>RaPropSheet::LinkStatusPage_OnInitDialog()==>\n"); 
    
    LinkStatusPage_Label_Channel->setText("Channel:");  
    
    
    LinkStatusPage_Label_Status->setText("Status:");    
    LinkStatusPage_Label_ExtraInfo->setText("Extra Info:");    
    LinkStatusPage_Label_LinkQuality->setText("Link Quality:");    
    LinkStatusPage_Label_SignalStrength->setText("Signal Strength:");    
    LinkStatusPage_Label_NoiseLevel->setText("Noise Level:");    
    LinkStatusPage_Label_LinkSpeedM->setText("Link Speed:");    
    LinkStatusPage_Label_LinkSpeed_TX->setText("Tx(Mbps):");    
    LinkStatusPage_Label_LinkSpeed_RX->setText("Rx(Mbps):");      
    LinkStatusPage_Label_ThroughputM->setText("Throughput:");
    LinkStatusPage_Label_Throughput_TX->setText("Tx(Kbps):"); 
    LinkStatusPage_Label_Throughput_RX->setText("Rx(Kbps):");        
    LinkStatusPage_CheckBox_dbm->setText("dBm");
    
   
        
    m_lTxCount = 0;   
    m_lRxCount = 0;
    m_nSigQua = 0;
    m_lChannelQuality = 0;
    
    DebugPrint("<func>RaPropSheet::LinkStatusPage_OnInitDialog()<==\n");        
}

void RaPropSheet::LinkStatusPage_OnSetActive()
{
    DebugPrint("<func>RaPropSheet::LinkStatusPage_OnSetActive()==>\n");    

    // Update Tx & Rx bytecount, and get correct average throughput
    RT_802_11_LINK_STATUS       LinkStatus;

    if (OidQueryInformation(RT_OID_802_11_QUERY_LINK_STATUS, m_nSocketId, m_strDeviceName, &LinkStatus, sizeof(LinkStatus)) >= 0)
    {
        m_lTxCount = LinkStatus.TxByteCount;
        m_lRxCount = LinkStatus.RxByteCount;
    }

    // Start timerId_LinkStatusPage_LinkStatus timer
    if(timerId_LinkStatusPage_LinkStatus == -1)
    {
        timerId_LinkStatusPage_LinkStatus = startTimer(2000);
    }
    
    DebugPrint("<func>RaPropSheet::LinkStatusPage_OnSetActive()<==\n");        
}

void RaPropSheet::LinkStatusPage_OnKillActive()
{
    DebugPrint("<func>RaPropSheet::LinkStatusPage_OnKillActive()==>\n");    

    // Kill timerId_LinkStatusPage_LinkStatus timer
    if(timerId_LinkStatusPage_LinkStatus != -1)
    {
        killTimer(timerId_LinkStatusPage_LinkStatus);
        timerId_LinkStatusPage_LinkStatus = -1;
    }
   
    DebugPrint("<func>RaPropSheet::LinkStatusPage_OnKillActive()<==\n");    
}

void RaPropSheet::LinkStatusPage_OnTimer(int nIDEvent)
{
    DebugPrint("<func>RaPropSheet::LinkStatusPage_OnTimer()==>\n");    

    if(nIDEvent == timerId_LinkStatusPage_LinkStatus)
    {
            LinkStatusPage_UpdateStatus();    
    }

    DebugPrint("<func>RaPropSheet::LinkStatusPage_OnTimer()<==\n");            
}
 
void RaPropSheet::LinkStatusPage_UpdateStatus()
{
    DebugPrint("<func>RaPropSheet::LinkStatusPage_UpdateStatus()==>\n");    

    QString	str;
    unsigned long lReturn=0, lBufLen;
    long oidReturn=0;
    
    //---------------------------------------------
    // Noise Level

	unsigned char lNoise; // this value is (ULONG) in Ndis driver (NOTICE!!!)
	int nNoiseDbm;
	int nNoisePercent;	
	QString qstrStrengthPercent; 
	
	// Get Noise Level From Driver
	
        oidReturn = OidQueryInformation(RT_OID_802_11_QUERY_NOISE_LEVEL, m_nSocketId, m_strDeviceName, &lNoise, sizeof(lNoise));     	

	DebugPrntFormat(DebugPrntBuf, "LinkStatusCheck: lNoise=0x%x, %d, oidReturn=%d\n", lNoise, lNoise, oidReturn);			DebugPrint(DebugPrntBuf);

	nNoiseDbm = lNoise;
	nNoiseDbm -= 143;
	nNoisePercent = (nNoiseDbm + 100) * 10 / 3;
    
	// Show the NoiseLevel Strength Word & Percentage
	
		// Word
	if(nNoisePercent > 90)
		LinkStatusPage_TextLabel_NoiseLevelStrengthWord->setText("Strength");
	else if(nNoisePercent > 50)
		LinkStatusPage_TextLabel_NoiseLevelStrengthWord->setText("Normal");
	else
		LinkStatusPage_TextLabel_NoiseLevelStrengthWord->setText("Low");


        LinkStatusPage_ProgressBar_NoiseLevel->setProgress(nNoisePercent);
		
		// Percentage	
	if(LinkStatusPage_CheckBox_dbm->isChecked())
	{
		qstrStrengthPercent.sprintf("%d dBm", nNoiseDbm);
		LinkStatusPage_TextLabel_NoiseLevelStrengthPercent->setText(qstrStrengthPercent);	
	}
	else
	{
		qstrStrengthPercent.sprintf("%d%%", nNoisePercent);
		LinkStatusPage_TextLabel_NoiseLevelStrengthPercent->setText(qstrStrengthPercent);		
	}
	
    //---------------------------------------------
    // ExtraInfo
    
        unsigned long lExtraInfo;
	
	oidReturn = OidQueryInformation(RT_OID_802_11_EXTRA_INFO, m_nSocketId, m_strDeviceName, &lExtraInfo, 4);
	
	if(oidReturn>=0)
	{
		if(lExtraInfo <= EXTRA_INFO_MAX)
		{
			for(UINT i = 0; i <= EXTRA_INFO_MAX; i++)
			{
				if(lExtraInfo == ExtraInfoTable[i].nExtraInfoDef)
				{
					m_strExtraInfo.sprintf(ExtraInfoTable[i].nExtraInfoString);
					LinkStatusPage_TextLabel_ExtraInfo->setText(m_strExtraInfo);
					break;
				}
			}
		}
		else
		{
			LinkStatusPage_TextLabel_ExtraInfo->setText("");
		}
	}
	else
	{
		LinkStatusPage_TextLabel_ExtraInfo->setText("");  
	}   
    
    //---------------------------------------------
    // Connect Status
    	NDIS_MEDIA_STATE                    ConnectStatus = NdisMediaStateDisconnected;
                   
    	oidReturn = OidQueryInformation(OID_GEN_MEDIA_CONNECT_STATUS, m_nSocketId, m_strDeviceName, &ConnectStatus, sizeof(ConnectStatus));

	DebugPrntFormat(DebugPrntBuf, "OID_GEN_MEDIA_CONNECT_STATUS: oidReturn=%d, ConnectStatus=0x%x\n\n", oidReturn, ConnectStatus);			DebugPrint(DebugPrntBuf);
	
	if(oidReturn<0)
	{			
		m_strStatus.sprintf(IDS_DRIVER_NOTOK);
		LinkStatusPage_TextLabel_Status->setText(m_strStatus);
		//---
		LinkStatusPage_TextLabel_Channel->setText("");		
		//---
		LinkStatusPage_TextLabel_TxRate->setText("");
		LinkStatusPage_TextLabel_RxRate->setText("");
		//---
		LinkStatusPage_TextLabel_TxThroughput->setText("");
		LinkStatusPage_TextLabel_RxThroughput->setText("");
		//---
		LinkStatusPage_TextLabel_LinkStrengthWord->setText("");
		LinkStatusPage_TextLabel_LinkStrengthPercent->setText("");		
		LinkStatusPage_ProgressBar_Link->setProgress(0);
		//---
		LinkStatusPage_TextLabel_SignalStrengthWord->setText("");
		LinkStatusPage_TextLabel_SignalStrengthPercent->setText("");				
		LinkStatusPage_ProgressBar_Signal->setProgress(0);
		//---
		LinkStatusPage_TextLabel_NoiseLevelStrengthWord->setText("");
		LinkStatusPage_TextLabel_NoiseLevelStrengthPercent->setText("");				
		LinkStatusPage_ProgressBar_Signal->setProgress(0);	
		return;		
	}
    		
	char StrTxPowerPercent[80];
	if(ConnectStatus == NdisMediaStateConnected)
	{
		NDIS_802_11_SSID SSID;
		ZeroMemory(&SSID, 36);
		OidQueryInformation(OID_802_11_SSID, m_nSocketId, m_strDeviceName, &SSID, 36);

		NDIS_802_11_MAC_ADDRESS Bssid;
		ZeroMemory(Bssid, 6);
		OidQueryInformation(OID_802_11_BSSID, m_nSocketId, m_strDeviceName, Bssid, 6);
		
		SSID.Ssid[SSID.SsidLength]=0;
		

		// Current Channel
		NDIS_802_11_CONFIGURATION Configuration;
		lBufLen = sizeof(NDIS_802_11_CONFIGURATION);
		
		OidQueryInformation(OID_802_11_CONFIGURATION, m_nSocketId, m_strDeviceName, &Configuration, lBufLen);
		int nChannel = -1;

		for(int i = 0; i < G_nChanFreqCount; i++)
		{
			if(Configuration.DSConfig == ChannelFreqTable[i].lFreq)
			{
				nChannel = ChannelFreqTable[i].lChannel;
				break;
			}
		}

		if(nChannel == -1)
		{
			DebugPrint("<warn>Can't find sutable nChannel\n");    		
		}
		else
		{
		
			m_strCurChan.sprintf("%u <--> %d KHz", nChannel, Configuration.DSConfig);
			LinkStatusPage_TextLabel_Channel->setText(m_strCurChan);				
		}

		ULONG lTxPowerPercent = 0; // Default 100
		oidReturn = OidQueryInformation(OID_802_11_TX_POWER_LEVEL, m_nSocketId, m_strDeviceName, &lTxPowerPercent, 4);

		lTxPowerPercent &= 0x000000FF;
		DebugPrntFormat(DebugPrntBuf, "LinkStatusCheck: lTxPowerPercent= 0x%x, %d, oidReturn=%d\n", lTxPowerPercent, lTxPowerPercent, oidReturn);			DebugPrint(DebugPrntBuf);
		
		if ((lTxPowerPercent == 0xFFFFFFFF) || (lTxPowerPercent == 100))
			sprintf(StrTxPowerPercent, "100%%");
		else if (lTxPowerPercent <= 6)
			sprintf(StrTxPowerPercent, "Lowest");
		else
			sprintf(StrTxPowerPercent, "%d%%", lTxPowerPercent);
			
		UCHAR IPAddress[4];
		BOOL bQuery = FALSE;
		bQuery = OidQueryInformation(RT_OID_802_11_QUERY_AIRONETIP_INFO, m_nSocketId, m_strDeviceName, IPAddress, 4);
			
		if( (bQuery<0) || (IPAddress[0] == 0) && (IPAddress[1] == 0) && (IPAddress[2] == 0) && (IPAddress[3] == 0))
		{
			m_strStatus.sprintf("%s <--> %02X-%02X-%02X-%02X-%02X-%02X", SSID.Ssid, 
				Bssid[0], Bssid[1], Bssid[2], Bssid[3], Bssid[4], Bssid[5]);
			LinkStatusPage_TextLabel_Status->setText(m_strStatus);				
		}
		else
		{
			m_strStatus.sprintf("%s <--> %02X-%02X-%02X-%02X-%02X-%02X [%d.%d.%d.%d]",
				SSID.Ssid, Bssid[0], Bssid[1], Bssid[2], Bssid[3], Bssid[4], Bssid[5], 
				IPAddress[0], IPAddress[1], IPAddress[2], IPAddress[3]);
			LinkStatusPage_TextLabel_Status->setText(m_strStatus);					
		}
		
	}
 	else
	{
		if(G_bRadio)
		{
			RT_802_11_STA_CONFIG configSta;
			OidQueryInformation(RT_OID_802_11_STA_CONFIG, m_nSocketId, m_strDeviceName, &configSta, sizeof(RT_802_11_STA_CONFIG));
			if(configSta.HwRadioStatus == 0) // Hardware radio off
				str.sprintf(IDS_RADIOOFF);
			else	
				str.sprintf(IDS_DISCONNECTED);
			m_strStatus = str;
			LinkStatusPage_TextLabel_Status->setText(m_strStatus);
			
		}
		else
		{
			str.sprintf(IDS_RADIOOFF);
			m_strStatus = str;
			LinkStatusPage_TextLabel_Status->setText(m_strStatus);			
		}
		
		//---
		LinkStatusPage_TextLabel_Channel->setText("");		
		//---
		LinkStatusPage_TextLabel_TxRate->setText("");
		LinkStatusPage_TextLabel_RxRate->setText("");
		//---
		LinkStatusPage_TextLabel_TxThroughput->setText("");
		LinkStatusPage_TextLabel_RxThroughput->setText("");
		//---
		LinkStatusPage_TextLabel_LinkStrengthWord->setText("");
		LinkStatusPage_TextLabel_LinkStrengthPercent->setText("");		
		LinkStatusPage_ProgressBar_Link->setProgress(0);
		//---
		LinkStatusPage_TextLabel_SignalStrengthWord->setText("");
		LinkStatusPage_TextLabel_SignalStrengthPercent->setText("");				
		LinkStatusPage_ProgressBar_Signal->setProgress(0);
		//---
		LinkStatusPage_TextLabel_NoiseLevelStrengthWord->setText("");
		LinkStatusPage_TextLabel_NoiseLevelStrengthPercent->setText("");				
		LinkStatusPage_ProgressBar_NoiseLevel->setProgress(0);	
		return;
	}
	
    //---------------------------------------------	
    // Get Last Rx Rate
	ULONG lLastRxRate;
	double fLastRxRate;
	
	OidQueryInformation(RT_OID_802_11_QUERY_LAST_RX_RATE, m_nSocketId, m_strDeviceName, &lLastRxRate, sizeof(lLastRxRate));
	
	if(lLastRxRate == 0)
		fLastRxRate = 1;
	else if(lLastRxRate == 1)
		fLastRxRate = 2;
	else if(lLastRxRate == 2)
		fLastRxRate = 5.5;
	else if(lLastRxRate == 3)
		fLastRxRate = 11;
	else if(lLastRxRate == 4)
		fLastRxRate = 6;
	else if(lLastRxRate == 5)
		fLastRxRate = 9;
	else if(lLastRxRate == 6)
		fLastRxRate = 12;
	else if(lLastRxRate == 7)
		fLastRxRate = 18;
	else if(lLastRxRate == 8)
		fLastRxRate = 24;
	else if(lLastRxRate == 9)
		fLastRxRate = 36;
	else if(lLastRxRate == 10)
		fLastRxRate = 48;
	else if(lLastRxRate == 11)
		fLastRxRate = 54;
	else
	{
		ASSERT(FALSE);
		fLastRxRate = 1;
	}

	DebugPrntFormat(DebugPrntBuf, "fLastRxRate = %d\n", fLastRxRate);
	DebugPrint(DebugPrntBuf);
		
	m_strLastRxRate.sprintf("%.1f", fLastRxRate);	
	LinkStatusPage_TextLabel_RxRate->setText(m_strLastRxRate);	
	
    //---------------------------------------------	
    // Get Link Status Info from driver
	RT_802_11_LINK_STATUS LinkStatus;
	lBufLen = sizeof(RT_802_11_LINK_STATUS);
	OidQueryInformation(RT_OID_802_11_QUERY_LINK_STATUS, m_nSocketId, m_strDeviceName, &LinkStatus, lBufLen);

    //---------------------------------------------	
    // Current Tx Rate LinkStatus.CurrTxRate / 2(secs)
	m_strCurTxRate.sprintf("%.1f", double(LinkStatus.CurrTxRate) / 2);

	LinkStatusPage_TextLabel_TxRate->setText(m_strCurTxRate);
	
	DebugPrntFormat(DebugPrntBuf, "LinkStatus.CurrTxRate/2 = %d\n", LinkStatus.CurrTxRate/2);
	DebugPrint(DebugPrntBuf);
		
    //---------------------------------------------	
    // Tx Throughput (KBits/sec) (LinkStatus.TxByteCount - m_lTxCount) * 8(bits) /1000 / 2(secs)
	m_strThroughTx.sprintf("%.1f", (double)(LinkStatus.TxByteCount - m_lTxCount) / 250);
	LinkStatusPage_TextLabel_TxThroughput->setText(m_strThroughTx);
	
	DebugPrntFormat(DebugPrntBuf, "LinkStatus.TxByteCount = %d , m_lTxCount = %d\n", LinkStatus.TxByteCount, m_lTxCount);
	DebugPrint(DebugPrntBuf);
	
	m_lTxCount = LinkStatus.TxByteCount;

    //---------------------------------------------	
    // Rx Throughput (KBits/sec) (LinkStatus.RxByteCount - m_lRxCount) * 8(bits) /1000 / 2(secs)
	m_strThroughRx.sprintf("%.1f", (double)(LinkStatus.RxByteCount - m_lRxCount) / 250);
	LinkStatusPage_TextLabel_RxThroughput->setText(m_strThroughRx);
	
	DebugPrntFormat(DebugPrntBuf, "LinkStatus.RxByteCount = %d , m_lTxCount = %d\n", LinkStatus.RxByteCount, m_lRxCount);
	DebugPrint(DebugPrntBuf);
		
	m_lRxCount = LinkStatus.RxByteCount;	
	
    //---------------------------------------------	
    // Link Quality
    
	LinkStatus.ChannelQuality = (ULONG)(LinkStatus.ChannelQuality * 1.2 + 10);
	if(LinkStatus.ChannelQuality > 100)
		LinkStatus.ChannelQuality = 100;
	if(m_lChannelQuality != 0)
		LinkStatus.ChannelQuality = (ULONG)((m_lChannelQuality + LinkStatus.ChannelQuality) / 2.0 + 0.5);

	m_lChannelQuality = LinkStatus.ChannelQuality;

	if(LinkStatus.ChannelQuality > 70)
	{
		m_LINK_QUALITY_STA.sprintf(IDS_LINK_GOOD);
	}
	else if(LinkStatus.ChannelQuality > 40)
	{
		m_LINK_QUALITY_STA.sprintf(IDS_LINK_NORMAL);
	}
	else
	{
		m_LINK_QUALITY_STA.sprintf(IDS_LINK_WEAK);
	}
	LinkStatusPage_TextLabel_LinkStrengthWord->setText(m_LINK_QUALITY_STA);
			
	m_strLinkQual.sprintf("%d%%", LinkStatus.ChannelQuality);
	LinkStatusPage_TextLabel_LinkStrengthPercent->setText(m_strLinkQual);
		
	LinkStatusPage_ProgressBar_Link->setProgress(LinkStatus.ChannelQuality);
		
    //----------------------------------------------
    // Signal Strength
    
    	// Get Rssi Value from driver
	NDIS_802_11_RSSI RSSI;
	lBufLen = sizeof(NDIS_802_11_RSSI);
	oidReturn = OidQueryInformation(OID_802_11_RSSI_TRIGGER, m_nSocketId, m_strDeviceName, &RSSI, lBufLen); // driver not yet implement the OID_802_11_RSSI oid , use OID_802_11_RSSI_TRIGGER oid instead (NOTICE!!!)

	DebugPrntFormat(DebugPrntBuf, "LinkStatusCheck: RSSI= 0x%x, %d, oidReturn=%d\n", RSSI, RSSI, oidReturn);			DebugPrint(DebugPrntBuf);
	
	// Use convert formula to getSignal Quality
	UINT nSigQua = ConvertRssiToSignalQuality(RSSI);
	if(m_nSigQua !=0)
	nSigQua = (UINT)((m_nSigQua + nSigQua) / 2.0 + 0.5);
	
	m_nSigQua = nSigQua;
	
	if(nSigQua > 70)
	{
		m_SIG_STR_STA.sprintf(IDS_LINK_GOOD);
		LinkStatusPage_TextLabel_SignalStrengthWord->setText(m_SIG_STR_STA);	
			
		if(LinkStatusPage_CheckBox_dbm->isChecked())
		{
			m_strSignal.sprintf("%d dBm", RSSI);
			LinkStatusPage_TextLabel_SignalStrengthPercent->setText(m_strSignal);		
		}
		else
		{
			m_strSignal.sprintf("%d%%", nSigQua);
			LinkStatusPage_TextLabel_SignalStrengthPercent->setText(m_strSignal);			
		}
	}
	else if(nSigQua > 40)
	{
		m_SIG_STR_STA.sprintf(IDS_LINK_NORMAL);
		LinkStatusPage_TextLabel_SignalStrengthWord->setText(m_SIG_STR_STA);
		
		if(LinkStatusPage_CheckBox_dbm->isChecked())
		{
			m_strSignal.sprintf("%d dBm", RSSI);
			LinkStatusPage_TextLabel_SignalStrengthPercent->setText(m_strSignal);			
		}
		else
		{
			m_strSignal.sprintf("%d%%", nSigQua);
			LinkStatusPage_TextLabel_SignalStrengthPercent->setText(m_strSignal);			
		}
	}
	else
	{
		m_SIG_STR_STA.sprintf(IDS_LINK_WEAK);
		LinkStatusPage_TextLabel_SignalStrengthWord->setText(m_SIG_STR_STA);
		
		if(LinkStatusPage_CheckBox_dbm->isChecked())
		{
			m_strSignal.sprintf("%d dBm", RSSI);
			LinkStatusPage_TextLabel_SignalStrengthPercent->setText(m_strSignal);			
		}
		else
		{
			m_strSignal.sprintf("%d%%", nSigQua);
			LinkStatusPage_TextLabel_SignalStrengthPercent->setText(m_strSignal);			
		}
	}
	   
    	LinkStatusPage_ProgressBar_Signal->setProgress(nSigQua);

    	// Tx Power In ExtraInfo
	if(ConnectStatus == NdisMediaStateConnected)
	{
		str.sprintf(" [TxPower:%s]", StrTxPowerPercent);
		m_strExtraInfo += str;
		
		LinkStatusPage_TextLabel_ExtraInfo->setText(m_strExtraInfo);
	}    
    
    DebugPrint("<func>RaPropSheet::LinkStatusPage_UpdateStatus()<==\n");    
    
}
