
//Site Survey Page    
public:
    QWidget*                SiteSurvPage_tab;
    QButtonGroup*           SiteSurvPage_ButtonGroup;
    QListView*              SiteSurvPage_ListView;
    QLineEdit*              SiteSurvPage_LineEdit_Status;
    QPushButton*            SiteSurvPage_PushButton_Rescan;
    QPushButton*            SiteSurvPage_PushButton_Connect;
    QPushButton*            SiteSurvPage_PushButton_AddProfile;    

    void SiteSurvPage_AddPage(QTabWidget* TabWidgetRaConfig);
    bool SiteSurvPage_OnInitDialog();
    void SiteSurvPage_OnSetActive();
    void SiteSurvPage_OnKillActive();
    void SiteSurvPage_OnTimer(int nIDEvent); 
    
    void SiteSurvPage_ProbeConnectStatus();
    void SiteSurvPage_RescanTimeFunc();
    void SiteSurvPage_UpdateConnectStatus(int nActiveItem, int nImageIdx);
    void SiteSurvPage_ButtonShowHide();
    NDIS_802_11_AUTHENTICATION_MODE SiteSurvPage_GetEncryStatus();
    bool SiteSurvPage_ResetOidValue(NDIS_802_11_NETWORK_INFRASTRUCTURE enumInfrastructureMode = Ndis802_11Infrastructure);
    
public:  
    UINT SiteSurvPage_IsItemWPA();
        
public:
    bool                    m_bSetBssid;
    bool                    m_bSetSsid;
    bool                    m_bRescan;    
    int                     m_nTimerCount_SiteSurvPage;     
    NDIS_802_11_SSID                m_SsidSet;
    NDIS_802_11_MAC_ADDRESS         m_BssidSet;   
 

private:
    PNDIS_802_11_BSSID_LIST_EX      m_pBssidList;        
        