
void RaPropSheet::AdvancePage_AddPage(QTabWidget* TabWidgetRaConfig)
{

//===============================================================================
//Advance Page
//===============================================================================

    AdvancePage_tab = new QWidget( TabWidgetRaConfig, "AdvancePage_tab" );

    AdvancePage_Label_AdhocWirelessMode = new QLabel( AdvancePage_tab, "AdvancePage_Label_AdhocWirelessMode" );
    AdvancePage_Label_AdhocWirelessMode->setGeometry( QRect( 10, 70, 147, 30 ) );

    AdvancePage_GroupBox_SelectCountryRegion = new QGroupBox( AdvancePage_tab, "AdvancePage_GroupBox_SelectCountryRegion" );
    AdvancePage_GroupBox_SelectCountryRegion->setGeometry( QRect( 360, 10, 200, 100 ) );

    AdvancePage_ComboBox_SelectCountryRegion = new QComboBox( FALSE, AdvancePage_GroupBox_SelectCountryRegion, "AdvancePage_ComboBox_SelectCountryRegion" );
    AdvancePage_ComboBox_SelectCountryRegion->setGeometry( QRect( 10, 30, 180, 31 ) );

    AdvancePage_ComboBox_AdhocWirelessMode = new QComboBox( FALSE, AdvancePage_tab, "AdvancePage_ComboBox_AdhocWirelessMode" );
    AdvancePage_ComboBox_AdhocWirelessMode->setGeometry( QRect( 160, 70, 180, 31 ) );

    AdvancePage_Label_InfraWirelessMode = new QLabel( AdvancePage_tab, "AdvancePage_Label_InfraWirelessMode" );
    AdvancePage_Label_InfraWirelessMode->setGeometry( QRect( 10, 20, 147, 30 ) );

    AdvancePage_ComboBox_InfraWirelessMode = new QComboBox( FALSE, AdvancePage_tab, "AdvancePage_ComboBox_InfraWirelessMode" );
    AdvancePage_ComboBox_InfraWirelessMode->setGeometry( QRect( 160, 20, 180, 31 ) );

    AdvancePage_CheckBox_EnableTxBurst = new QCheckBox( AdvancePage_tab, "AdvancePage_CheckBox_EnableTxBurst" );
    AdvancePage_CheckBox_EnableTxBurst->setGeometry( QRect( 30, 230, 200, 30 ) );

    AdvancePage_CheckBox_UseShortSlotTime = new QCheckBox( AdvancePage_tab, "AdvancePage_CheckBox_UseShortSlotTime" );
    AdvancePage_CheckBox_UseShortSlotTime->setEnabled( FALSE );
    AdvancePage_CheckBox_UseShortSlotTime->setGeometry( QRect( 30, 280, 200, 30 ) );

    AdvancePage_CheckBox_UseTurboRate = new QCheckBox( AdvancePage_tab, "AdvancePage_CheckBox_UseTurboRate" );
    AdvancePage_CheckBox_UseTurboRate->setEnabled( FALSE );
    AdvancePage_CheckBox_UseTurboRate->setGeometry( QRect( 30, 320, 200, 30 ) );

    AdvancePage_Label_BgProtection = new QLabel( AdvancePage_tab, "AdvancePage_Label_BgProtection" );
    AdvancePage_Label_BgProtection->setGeometry( QRect( 40, 140, 120, 30 ) );

    AdvancePage_ComboBox_BgProtection = new QComboBox( FALSE, AdvancePage_tab, "AdvancePage_ComboBox_BgProtection" );
    AdvancePage_ComboBox_BgProtection->setEnabled( FALSE );
    AdvancePage_ComboBox_BgProtection->setGeometry( QRect( 170, 140, 120, 30 ) );

    AdvancePage_Label_TxRate = new QLabel( AdvancePage_tab, "AdvancePage_Label_TxRate" );
    AdvancePage_Label_TxRate->setGeometry( QRect( 40, 180, 120, 30 ) );

    AdvancePage_ComboBox_TxRate = new QComboBox( FALSE, AdvancePage_tab, "AdvancePage_ComboBox_TxRate" );
    AdvancePage_ComboBox_TxRate->setGeometry( QRect( 170, 180, 121, 31 ) );

    AdvancePage_Label_RadioStatus = new QLabel( AdvancePage_tab, "AdvancePage_Label_RadioStatus" );
    AdvancePage_Label_RadioStatus->setGeometry( QRect( 18, 378, 59, 31 ) );

    AdvancePage_PushButton_RadioStatus = new QPushButton( AdvancePage_tab, "AdvancePage_PushButton_RadioStatus" );
    AdvancePage_PushButton_RadioStatus->setGeometry( QRect( 80, 380, 120, 30 ) );

    AdvancePage_PushButton_Apply = new QPushButton( AdvancePage_tab, "AdvancePage_PushButton_Apply" );
    AdvancePage_PushButton_Apply->setGeometry( QRect( 420, 380, 121, 31 ) );

    TabWidgetRaConfig->insertTab( AdvancePage_tab, "Advance");

    connect( AdvancePage_PushButton_RadioStatus, SIGNAL( clicked() ), this, SLOT( AdvancePage_OnRadio() ) );
    connect( AdvancePage_PushButton_Apply, SIGNAL( clicked() ), this, SLOT( AdvancePage_OnApply() ) );
    connect( AdvancePage_ComboBox_InfraWirelessMode, SIGNAL( activated(int) ), this, SLOT( AdvancePage_OnSelchangeInfraWirelessMode(int) ) );    
    connect( AdvancePage_ComboBox_AdhocWirelessMode, SIGNAL( activated(int) ), this, SLOT( AdvancePage_OnSelchangeAdhocWirelessMode(int) ) );    	
    connect( AdvancePage_ComboBox_SelectCountryRegion, SIGNAL( activated(int) ), this, SLOT( AdvancePage_OnSelchangeCountryRegion(int) ) );    	

    //---------------------------------------------------------------------------------------------------------------	
    AdvancePage_Label_InfraWirelessMode->setText("Wireless Mode (Infra)");

    AdvancePage_ComboBox_InfraWirelessMode->insertItem("802.11 B/G mixed mode");
    AdvancePage_ComboBox_InfraWirelessMode->insertItem("802.11 B only");

    AdvancePage_Label_AdhocWirelessMode->setText("Wireless Mode (Adhoc)");

    AdvancePage_ComboBox_AdhocWirelessMode->insertItem("802.11 B only");
    AdvancePage_ComboBox_AdhocWirelessMode->insertItem("802.11 B/G mixed mode");
    AdvancePage_ComboBox_AdhocWirelessMode->insertItem("802.11 G only");

    AdvancePage_GroupBox_SelectCountryRegion->setTitle(" Select your Country Region ");
	
    AdvancePage_ComboBox_SelectCountryRegion->insertItem("0: FCC, CH1-11");	 
    AdvancePage_ComboBox_SelectCountryRegion->insertItem("1: IC (Canada), CH1-11");	 
    AdvancePage_ComboBox_SelectCountryRegion->insertItem("2: ETSI, CH1-13");	 
    AdvancePage_ComboBox_SelectCountryRegion->insertItem("3: SPAIN, CH10-11");	 
    AdvancePage_ComboBox_SelectCountryRegion->insertItem("4: FRANCE, CH10-13");	 
    AdvancePage_ComboBox_SelectCountryRegion->insertItem("5: MKK, CH14");	 
    AdvancePage_ComboBox_SelectCountryRegion->insertItem("6: MKK1(TELEC), CH1-14");	 
    AdvancePage_ComboBox_SelectCountryRegion->insertItem("7: ISRAEL, CH3-9");	 	

    AdvancePage_CheckBox_EnableTxBurst->setText("Enable TX Burst");

    AdvancePage_CheckBox_UseShortSlotTime->setEnabled( FALSE );
    AdvancePage_CheckBox_UseShortSlotTime->setText("Use Short Slot Time when applicable");

    AdvancePage_CheckBox_UseTurboRate->setEnabled( FALSE );
    AdvancePage_CheckBox_UseTurboRate->setText("Use Turbo rate (72/100Mbps) when applicable");

    AdvancePage_Label_BgProtection->setText("11B/G Protection");

    AdvancePage_ComboBox_BgProtection->insertItem("Auto");
    AdvancePage_ComboBox_BgProtection->insertItem("On");
    AdvancePage_ComboBox_BgProtection->insertItem("Off");
    AdvancePage_ComboBox_BgProtection->setEnabled( TRUE );

    AdvancePage_Label_TxRate->setText("TX Rate");

    AdvancePage_ComboBox_TxRate->insertItem("Auto");
    AdvancePage_ComboBox_TxRate->insertItem("1 Mbps");
    AdvancePage_ComboBox_TxRate->insertItem("2 Mbps");
    AdvancePage_ComboBox_TxRate->insertItem("5.5 Mbps");
    AdvancePage_ComboBox_TxRate->insertItem("11 Mbps");
    AdvancePage_ComboBox_TxRate->insertItem("6 Mbps");
    AdvancePage_ComboBox_TxRate->insertItem("9 Mbps");
    AdvancePage_ComboBox_TxRate->insertItem("12 Mbps");
    AdvancePage_ComboBox_TxRate->insertItem("18 Mbps");
    AdvancePage_ComboBox_TxRate->insertItem("24 Mbps");
    AdvancePage_ComboBox_TxRate->insertItem("36 Mbps");
    AdvancePage_ComboBox_TxRate->insertItem("48 Mbps");
    AdvancePage_ComboBox_TxRate->insertItem("54 Mbps");

    AdvancePage_Label_RadioStatus->setText("");
    AdvancePage_Label_RadioStatus->setPixmap( uic_load_pixmap_RaPropSheet( "radioon.png" ) );

    AdvancePage_PushButton_RadioStatus->setText("&RADIO OFF");

    AdvancePage_PushButton_Apply->setText("&APPLY");

    AdvancePage_CheckBox_UseShortSlotTime->hide();
    AdvancePage_CheckBox_UseTurboRate->hide();
		
    //---------------------------------------------------------------------------------------------------------------
    
}

bool RaPropSheet::AdvancePage_OnInitDialog()
{

}

void RaPropSheet::AdvancePage_OnSetActive()
{

    AdvancePage_ReadConfigFromRegistry();
	
    if(G_bSupportAMode)
    {
        AdvancePage_ComboBox_InfraWirelessMode->insertItem("802.11 A only");
        AdvancePage_ComboBox_InfraWirelessMode->insertItem("802.11 A/B/G mixed mode");
    }

    if(G_bRadio)
    {
        AdvancePage_PushButton_RadioStatus->setText("RADIO OFF");
        AdvancePage_Label_RadioStatus->setPixmap( uic_load_pixmap_RaPropSheet( "radioon.png" ) );
    }
    else
    {
        AdvancePage_PushButton_RadioStatus->setText("RADIO ON");
        AdvancePage_Label_RadioStatus->setPixmap( uic_load_pixmap_RaPropSheet( "radiooff.png" ) );
    }
	
    AdvancePage_OnSelchangeInfraWirelessMode( AdvancePage_ComboBox_InfraWirelessMode->currentItem());
    AdvancePage_ComboBox_AdhocWirelessMode->setCurrentItem(m_bAdhocOfdm);
    AdvancePage_ComboBox_SelectCountryRegion->setCurrentItem(G_nCountryRegion);


	
}

void RaPropSheet::AdvancePage_OnKillActive()
{

}

void RaPropSheet::AdvancePage_OnTimer(int nIDEvent)
{
    if(nIDEvent == timerId_ConnectStatus)
    {
//            LinkStatusPage_UpdateStatus();    
    }
}
 
void RaPropSheet::AdvancePage_OnApply()
{
    DebugPrint("<func>RaPropSheet::AdvancePage_OnApply()==>\n");


    RT_802_11_PHY_MODE          enumWirelessMode;
    RT_802_11_STA_CONFIG        configStation;
    RT_802_11_STA_CONFIG        configOldStation;
    NDIS_802_11_RATES           aryRates;
    char                        strtmp[255];

    m_nTXRate = AdvancePage_ComboBox_TxRate->currentItem();

    if (!G_bSupportAMode && (m_WirelessMode >= PHY_11A))
    {
	 DebugPrint("PHY_11BG_MIXED\n");
    
        m_WirelessMode = PHY_11BG_MIXED;
    }

    if (((m_WirelessMode == PHY_11B) && (m_nTXRate > 4)) || ((m_WirelessMode == PHY_11A) && (m_nTXRate > 8)))
    {
	 DebugPrint("((m_WirelessMode == PHY_11B) && (m_nTXRate > 4)) || ((m_WirelessMode == PHY_11A) && (m_nTXRate > 8)) --> m_nTXRate=0\n");
    
        m_nTXRate = 0;
    }

    m_bTurboRate = AdvancePage_CheckBox_UseTurboRate->isChecked();
    m_bTXBurst = AdvancePage_CheckBox_EnableTxBurst->isChecked();
    m_bShortSlot = AdvancePage_CheckBox_UseShortSlotTime->isChecked();
    switch (AdvancePage_ComboBox_BgProtection->currentItem())
    {
    case 1://1-always ON
        m_nBGProtection = 1;
        break;
    case 2://2-always OFF
        m_nBGProtection = 2;
        break;
    case 0:// 0-AUTO
    default:
        m_nBGProtection = 0;
        break;
    }

    G_enumWirelessMode = (RT_802_11_PHY_MODE)m_WirelessMode;
    if ((m_WirelessMode == PHY_11B) || (m_WirelessMode == PHY_11A))
    {
	 DebugPrint("(PHY_11B || PHY_11A) --> m_nBGProtection = 0;\n");
	 
        m_nBGProtection = 0;
    }
	
    if (G_bUserAdmin)
    {
        // Set Wireless Mode value
        sprintf(strtmp, "%d", m_WirelessMode);
        writekeystring("Default", "WirelessMode", strtmp, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);

        //Set AdhocOfdm
        sprintf(strtmp, "%d", m_bAdhocOfdm);
        writekeystring("Default", "AdhocOfdm", strtmp, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);

	// Set CountryRegion Value
        sprintf(strtmp, "%d", G_nCountryRegion);
        writekeystring("Default", "CountryRegion", strtmp, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
		
        // Set TXBurst value
        sprintf(strtmp, "%d", m_bTXBurst);
        writekeystring("Default", "TXBurst", strtmp, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
        
        // Set TurboRate value
        sprintf(strtmp, "%d", m_bTurboRate);
        writekeystring("Default", "TurboRate", strtmp, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);

        // Set BGProtection value
        sprintf(strtmp, "%d", m_nBGProtection);
        writekeystring("Default", "BGProtection", strtmp, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);

        // Set ShortSlot value
        sprintf(strtmp, "%d", m_bShortSlot);
        writekeystring("Default", "ShortSlot", strtmp, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);

        // Set TXRate value
        sprintf(strtmp, "%d", m_nTXRate);
        writekeystring("Default", "TxRate", strtmp, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
	
    }

    DebugPrint("Begin set Oid to driver!!!!!!\n");
 
    
    // SetOidInformation
    DebugPrint("Query, then Set RT_OID_802_11_PHY_MODE\n");    
    OidQueryInformation(RT_OID_802_11_PHY_MODE, m_nSocketId, m_strDeviceName, &enumWirelessMode, sizeof(enumWirelessMode));
    if(enumWirelessMode != G_enumWirelessMode)
        OidSetInformation(RT_OID_802_11_PHY_MODE, m_nSocketId, m_strDeviceName, &G_enumWirelessMode, sizeof(G_enumWirelessMode));

    DebugPrint("Query, then Set RT_OID_802_11_STA_CONFIG\n");
    OidQueryInformation(RT_OID_802_11_STA_CONFIG, m_nSocketId, m_strDeviceName, &configOldStation, sizeof(configOldStation));

    configStation.EnableTurboRate = m_bTurboRate;
    configStation.EnableTxBurst = m_bTXBurst;
    configStation.UseBGProtection = m_nBGProtection;
    configStation.UseShortSlotTime = m_bShortSlot;
    configStation.AdhocMode = m_bAdhocOfdm;

    if(memcmp(&configOldStation, &configStation, sizeof(RT_802_11_STA_CONFIG)) != 0)        
        OidSetInformation(RT_OID_802_11_STA_CONFIG, m_nSocketId, m_strDeviceName, &configStation, sizeof(configStation));

    DebugPrint("Set RT_OID_802_11_COUNTRY_REGION\n");     
    UCHAR chCountryRegion = (UCHAR)G_nCountryRegion;
    OidSetInformation(RT_OID_802_11_COUNTRY_REGION, m_nSocketId, m_strDeviceName, &chCountryRegion, sizeof(chCountryRegion));    
    
    memset(aryRates, 0x00, sizeof(NDIS_802_11_RATES));
    if (m_WirelessMode == PHY_11A)
    {
        switch (m_nTXRate)
        {
        case 0:
            aryRates[0] = 0x6c; // 54Mbps
            aryRates[1] = 0x60; // 48Mbps
            aryRates[2] = 0x48; // 36Mbps
            aryRates[3] = 0x30; // 24Mbps
            aryRates[4] = 0x24; // 18M
            aryRates[5] = 0x18; // 12M
            aryRates[6] = 0x12; // 9M
            aryRates[7] = 0x0c; // 6M
            break;
        case 1:
            aryRates[0] = 0x0c; // 6M
            break;
        case 2:
            aryRates[0] = 0x12; // 9M
            break;
        case 3:
            aryRates[0] = 0x18; // 12M
            break;
        case 4:
            aryRates[0] = 0x24; // 18M
            break;
        case 5:
            aryRates[0] = 0x30; // 24M
            break;
        case 6:
            aryRates[0] = 0x48; // 36M
            break;
        case 7:
            aryRates[0] = 0x60; // 48M
            break;
        case 8:
            aryRates[0] = 0x6c; // 54M
            break;
        }
    }
    else if ((m_WirelessMode == PHY_11BG_MIXED) || (m_WirelessMode == PHY_11B) ||
             (m_WirelessMode == PHY_11ABG_MIXED))
    {
        switch(m_nTXRate)
        {
        case 0:
            switch(m_WirelessMode)
            {
            case PHY_11BG_MIXED: // B/G Mixed
            case PHY_11ABG_MIXED: // A/B/G Mixed
                aryRates[0] = 0x6c; // 54Mbps
                aryRates[1] = 0x60; // 48Mbps
                aryRates[2] = 0x48; // 36Mbps
                aryRates[3] = 0x30; // 24Mbps
                aryRates[4] = 0x16; // 11Mbps
                aryRates[5] = 0x0b; // 5.5Mbps
                aryRates[6] = 0x04; // 2Mbps
                aryRates[7] = 0x02; // 1Mbps
                break;
            case PHY_11B: // B Only
                aryRates[0] = 0x16; // 11Mbps
                aryRates[1] = 0x0b; // 5.5Mbps
                aryRates[2] = 0x04; // 2Mbps
                aryRates[3] = 0x02; // 1Mbps
                break;
            case PHY_11A:
                break;   //Not be call, for avoid warning.
            }
            break;
        case 1:
            aryRates[0] = 0x02; // 1M
            break;
        case 2:
            aryRates[0] = 0x04; // 2M
            break;
        case 3:
            aryRates[0] = 0x0b; // 5.5M
            break;
        case 4:
            aryRates[0] = 0x16; // 11M
            break;
        case 5:
            aryRates[0] = 0x0c; // 6M
            break;
        case 6:
            aryRates[0] = 0x12; // 9M
            break;
        case 7:
            aryRates[0] = 0x18; // 12M
            break;
        case 8:
            aryRates[0] = 0x24; // 18M
            break;
        case 9:
            aryRates[0] = 0x30; // 24M
            break;
        case 10:
            aryRates[0] = 0x48; // 36M
            break;
        case 11:
            aryRates[0] = 0x60; // 48M
            break;
        case 12:
            aryRates[0] = 0x6c; // 54M
            break;
        }
    }

    DebugPrntFormat(DebugPrntBuf, "aryRates[0~7] = 0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x.\n", aryRates[0], aryRates[1], aryRates[2], aryRates[3], aryRates[4], aryRates[5], aryRates[6], aryRates[7]);		DebugPrint(DebugPrntBuf);

    DebugPrint("Set OID_802_11_DESIRED_RATES\n");
	
    OidSetInformation(OID_802_11_DESIRED_RATES, m_nSocketId, m_strDeviceName, &aryRates, sizeof(NDIS_802_11_RATES));

    DebugPrint("<func>RaPropSheet::AdvancePage_OnApply()<==\n");	
}

void RaPropSheet::AdvancePage_ReadConfigFromRegistry()
{
    DebugPrint("<func>RaPropSheet::AdvancePage_ReadConfigFromRegistry()==>\n");
	
    char            strtmp[255];
    unsigned int    nWirelessMode;

    if (getkeystring("Default", "WirelessMode",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
    {
        nWirelessMode = atoi(strtmp);

        if (G_bSupportAMode)
        {
	    DebugPrint("G_bSupportAMode\n");
        
            if ( nWirelessMode > PHY_11ABG_MIXED )
            {
	         DebugPrint("(nWirelessMode > PHY_11ABG_MIXED) --> PHY_11ABG_MIXED\n");            
                m_WirelessMode = PHY_11ABG_MIXED;                
            }
            else
            {
	         DebugPrint("!(nWirelessMode > PHY_11ABG_MIXED)\n");                        
                m_WirelessMode = (RT_802_11_PHY_MODE) nWirelessMode;
            }
        }
        else
        {
	    DebugPrint("!G_bSupportAMode\n");
		
            if (nWirelessMode >= PHY_11A )
            {
	         DebugPrint("(nWirelessMode >= PHY_11A ) --> PHY_11BG_MIXED\n");                        
                m_WirelessMode = PHY_11BG_MIXED;
            }
            else
            {
	         DebugPrint("!(nWirelessMode >= PHY_11A )\n");            			 
                m_WirelessMode = (RT_802_11_PHY_MODE) nWirelessMode;
            }

        }
        AdvancePage_ComboBox_InfraWirelessMode->setCurrentItem( (int)m_WirelessMode);
    }
    
    if (getkeystring("Default", "AdhocOfdm",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
    {
            m_bAdhocOfdm = atoi(strtmp);
    }

    if (getkeystring("Default", "CountryRegion",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
    {
            G_nCountryRegion = atoi(strtmp);
    }
		
    if (getkeystring("Default", "TXBurst",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
    {
        if (atoi(strtmp) != 0)
        {
            DebugPrint("m_bTXBurst = TRUE\n");                        
        
            m_bTXBurst = TRUE;
        }
        else
        {
            DebugPrint("m_bTXBurst = FALSE\n");                        
			
            m_bTXBurst = FALSE;
        }

        AdvancePage_CheckBox_EnableTxBurst->setChecked(m_bTXBurst);
    }

    if (getkeystring("Default", "TurboRate",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
    {
        if (atoi(strtmp) != 0)
        {
            DebugPrint("m_bTurboRate = TRUE\n");                        
			
            m_bTurboRate = TRUE;
        }
        else
        {
            DebugPrint("m_bTurboRate = FALSE\n");                        
			
            m_bTurboRate = FALSE;
        }

        AdvancePage_CheckBox_UseTurboRate->setChecked(m_bTurboRate);
    }

    if (getkeystring("Default", "ShortSlot",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
    {
        if (atoi(strtmp) != 0)
        {
            DebugPrint("m_bShortSlot = TRUE\n");                        
        
            m_bShortSlot = TRUE;
        }
        else
        {
            DebugPrint("m_bShortSlot = FALSE\n");                        
			
            m_bShortSlot = FALSE;
        }

        AdvancePage_CheckBox_UseShortSlotTime->setChecked(m_bShortSlot);
    }
    
    if (getkeystring("Default", "BGProtection",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
    {
        m_nBGProtection = atoi(strtmp);

        if ((m_nBGProtection < 0) || (m_nBGProtection >= 3))
            m_nBGProtection = 0;

        AdvancePage_ComboBox_BgProtection->setCurrentItem(m_nBGProtection);
    }

    if (getkeystring("Default", "TxRate",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
    {
        m_nTXRate = atoi(strtmp);

        AdvancePage_ComboBox_TxRate->setCurrentItem(m_nTXRate);
    }

    DebugPrint("<func>RaPropSheet::AdvancePage_ReadConfigFromRegistry()<==\n");
}

void RaPropSheet::AdvancePage_OnSelchangeInfraWirelessMode(int index)
{
    m_WirelessMode = (RT_802_11_PHY_MODE)index;
	
    AdvancePage_ComboBox_TxRate->clear();
    AdvancePage_ComboBox_AdhocWirelessMode->clear();

    switch(m_WirelessMode)
    {
        case PHY_11B: // B only
            AdvancePage_ComboBox_TxRate->insertItem(IDS_AUTO);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_1MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_2MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_5d5MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_11MBPS);
            AdvancePage_ComboBox_BgProtection->setEnabled(FALSE);

		AdvancePage_ComboBox_AdhocWirelessMode->insertItem(IDS_BONLY);

            m_nBGProtection = 0;
            if(m_nTXRate > 4)
                m_nTXRate = 0;
            break;
        case PHY_11A: // A Only
            AdvancePage_ComboBox_TxRate->insertItem(IDS_AUTO);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_6MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_9MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_12MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_18MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_24MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_36MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_48MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_54MBPS);
            AdvancePage_ComboBox_BgProtection->setEnabled(FALSE);

            m_nBGProtection = 0;
            if(m_nTXRate > 8)
                m_nTXRate = 0;
            break;
        case PHY_11BG_MIXED: // B/G Mixed
        case PHY_11ABG_MIXED: // A/B/G Mixed
        default:
            AdvancePage_ComboBox_TxRate->insertItem(IDS_AUTO);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_1MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_2MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_5d5MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_11MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_6MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_9MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_12MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_18MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_24MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_36MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_48MBPS);
            AdvancePage_ComboBox_TxRate->insertItem(IDS_54MBPS);
//          AdvancePage_ComboBox_TxRate->insertItem("72 Mbps");
//          AdvancePage_ComboBox_TxRate->insertItem("100 Mbps");

		AdvancePage_ComboBox_AdhocWirelessMode->insertItem(IDS_BONLY);
		AdvancePage_ComboBox_AdhocWirelessMode->insertItem(IDS_BGMIX);
		AdvancePage_ComboBox_AdhocWirelessMode->insertItem(IDS_GONLY);		
		
            if (G_bUserAdmin)
                AdvancePage_ComboBox_BgProtection->setEnabled(TRUE);

            if(m_nTXRate > 12)
                m_nTXRate = 0;
            break;
    }	

#if 0
    AdvancePage_ComboBox_TxRate->clear();

    if (index == 0)
        m_WirelessMode = PHY_11BG_MIXED;
    else
        m_WirelessMode = PHY_11B;

    switch(m_WirelessMode)
    {
        case PHY_11B: // B only
            AdvancePage_ComboBox_TxRate->insertItem("Auto");
            AdvancePage_ComboBox_TxRate->insertItem("1 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("2 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("5.5 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("11 Mbps");
            AdvancePage_ComboBox_BgProtection->setEnabled(FALSE);

            m_nBGProtection = 0;
            if(m_nTXRate > 4)
                m_nTXRate = 0;
            break;
        case PHY_11A: // A Only
            AdvancePage_ComboBox_TxRate->insertItem("Auto");
            AdvancePage_ComboBox_TxRate->insertItem("6 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("9 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("12 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("18 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("24 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("36 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("48 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("54 Mbps");
            AdvancePage_ComboBox_BgProtection->setEnabled(FALSE);

            m_nBGProtection = 0;
            if(m_nTXRate > 8)
                m_nTXRate = 0;
            break;
        case PHY_11BG_MIXED: // B/G Mixed
        case PHY_11ABG_MIXED: // A/B/G Mixed
        default:
            AdvancePage_ComboBox_TxRate->insertItem("Auto");
            AdvancePage_ComboBox_TxRate->insertItem("1 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("2 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("5.5 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("11 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("6 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("9 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("12 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("18 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("24 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("36 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("48 Mbps");
            AdvancePage_ComboBox_TxRate->insertItem("54 Mbps");
//          AdvancePage_ComboBox_TxRate->insertItem("72 Mbps");
//          AdvancePage_ComboBox_TxRate->insertItem("100 Mbps");

            if (G_bUserAdmin)
                AdvancePage_ComboBox_BgProtection->setEnabled(TRUE);

            if(m_nTXRate > 12)
                m_nTXRate = 0;
            break;
    }

    AdvancePage_ComboBox_TxRate->setCurrentItem(m_nTXRate);
#endif	
}

void RaPropSheet::AdvancePage_OnSelchangeAdhocWirelessMode(int index)
{
	m_bAdhocOfdm = index;
}

void RaPropSheet::AdvancePage_OnSelchangeCountryRegion(int index)
{
	G_nCountryRegion = index;
}

void RaPropSheet::AdvancePage_OnRadio()
{
    DebugPrint("<func>RaPropSheet::AdvancePage_OnRadio()==>\n");

    char            strtmp[255];

    G_bRadio = !G_bRadio;

    DebugPrntFormat(DebugPrntBuf, "G_bRadio = %d\n", G_bRadio);		DebugPrint(DebugPrntBuf);

    if (OidSetInformation(RT_OID_802_11_RADIO, m_nSocketId, m_strDeviceName, &G_bRadio, sizeof(G_bRadio)) >= 0)
    { //Set success
	 DebugPrint("Set RT_OID_802_11_RADIO oid success\n");
    
        if (G_bRadio)
        {
	     DebugPrint("(G_bRadio) RadioOn\n");
			
            AdvancePage_PushButton_RadioStatus->setText("RADIO OFF");
            AdvancePage_Label_RadioStatus->setPixmap( uic_load_pixmap_RaPropSheet( "radioon.png" ) );        
        }
        else
        {
	     DebugPrint("(G_bRadio) RadioOff\n");

            AdvancePage_PushButton_RadioStatus->setText("RADIO ON");
            AdvancePage_Label_RadioStatus->setPixmap( uic_load_pixmap_RaPropSheet( "radiooff.png" ) );
        }

        if (G_bUserAdmin)
        {
            sprintf(strtmp, "%d", G_bRadio);
            writekeystring("Default", "Radio", strtmp, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
        }
    }
    else
    { //Set failed
	 DebugPrint("Set RT_OID_802_11_RADIO oid fail\n");
	 
        G_bRadio = !G_bRadio;
    }

//    OidSetInformation(OID_802_11_BSSID_LIST_SCAN, m_nSocketId, m_strDeviceName, 0, 0);
//    LinkStatusPage_UpdateStatus();
//    ProfilePage_UpdateProfileStatus();
//    SiteSurvPage_ProbeConnectStatus();

    DebugPrint("<func>RaPropSheet::AdvancePage_OnRadio()<==\n");
	
}
